! -*- F90 -*-
 
      SUBROUTINE CPUTIM(TIM)
        implicit none 
        REAL*8 :: tim
!
!     UNIX SYSTEM
!
        REAL T(2),SEC1,ETIME
        SEC1=ETIME(T)
        TIM=DBLE(T(1)+T(2))
      END SUBROUTINE CPUTIM
!
      REAL*8 FUNCTION CPTIME(I)
        implicit none
        INTEGER :: I, ix1,ix2
        real*8 :: x,x2
!
        IF (I.EQ.1) THEN
         CALL CPUTIM(X)
         CPTIME=X
        ELSEIF (I.EQ.4.OR.I.EQ.3) THEN
         CALL CPUTIM(X)
         IX1=INT(X/3600.)
         IX2=INT((X-REAL(IX1*3600))/60.)
         X2=X-REAL(IX1*3600 + IX2*60)
         IF (I.EQ.4) THEN
          CALL TIMING(' ALL ')
          WRITE(6,*)
          WRITE (6,9991) IX1,IX2,X2
         END IF
9991     FORMAT(' TOTAL CPUTIME: ',I5,' hrs ',I3,' mins and ', &
              f7.4,' secs')
         CPTIME=X
        ENDIF
      END FUNCTION CPTIME
!
      SUBROUTINE SECNND(X)
        implicit none
        REAL*8 :: X,CPTIME
        X=CPTIME(1)
      END SUBROUTINE SECNND
!
      SUBROUTINE TIMG(NOMZ)
        implicit none 
        CHARACTER*4 :: NOMZ
        real*8 :: ft
        CALL SECNND(FT)
        WRITE(6,100) NOMZ,FT
100     FORMAT(1X,53('T'),1X,A4,' CPU',F11.3)
      END SUBROUTINE TIMG
!
      SUBROUTINE TIMING(NOMZ)
        implicit none 
        CHARACTER*4 :: NOMZ
        real*8 :: ft
        CALL SECNND(FT)
        WRITE(6,100) NOMZ,FT
100     FORMAT(1X,53('T'),1X,A4,' CPU',F11.3)
        CALL FLUSH(6)
      END SUBROUTINE TIMING
